/* install the DELTA IM module for sre2002 */

/* Load up advanced REXX functions */
call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

crlf='0d0a'x
copyall=0


/*---   Load REXX libraries ----- */
/* Load up advanced REXX functions */
foo=rxfuncquery('sysloadfuncs')
if foo=1 then do
  call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
  call SysLoadFuncs
end
foo=rxfuncquery('rexxlibregister')
if foo=1 then do
 call rxfuncadd 'rexxlibregister','rexxlib', 'rexxlibregister'
 call rexxlibregister
end
foo=rxfuncquery('rexxlibregister')
if foo=1 then do
   say "Caution: could not find REXXLIB (is it in your LIBPATH?) "
   say "(hit ENTER to continue)"
   pull ff
end /* do */


ansion=checkansi()
if ansion=1 then do
  aesc='1B'x
  cy_ye=aesc||'[37;46;m'
  normal=aesc||'[0;m'
  bold=aesc||'[1;m'
  re_wh=aesc||'[31;47;m'
  reverse=aesc||'[7;m'
end
else do
  say " Warning: Could not detect ANSI....  Install will look ugly ! "
  parse pull .
  cy_ye="" ; normal="" ; bold="" ;re_wh="" ;
  reverse=""
end  /* Do */

cls
say  " " ; say

call lineout, bold cy_ye
call lineout, "The DELTA IM Module for SRE2002 (ver 1.01) installation program (1/02). "
say "" 


say " This installation program program will ask for the names of a few directories,"
say " and will copy a number of files to these directories."normal
say "  "

aa=yesno(' Would you like to: ','Exit Continue View_Documentation','C')
if aa=0 then do
 say " See you later?.. "
 exit
end
if aa=2 then do
    say " Okay, viewing the SRE2002 manual ... "
     '@START  "The DELTA IM Module Manual" /C /F /WIN E DELTA.DOC'
    say ' '
end

/* check status of sre2002 and macrospace routines */
a=dosswitchlist('l2')
do mm=1 to a
 foo=upper(strip(filespec('n',l2.mm)))
 if foo='SRE2002.CMD' then do
     say bold " SRE2002 appears to be running " normal
     say " Please shut down SRE2002  before you install the DELTA module "
      exit
  end  /* Do */
end /* do */


/* -------- Create directories */
call make_dirs


/* directories created, copy stuff over */
dll_dir=strip(godir,,'\')||'\DLL'
cfg_dir=strip(godir,,'\')||'\CFG'
say 
say "Copying files to " im_dir
foo=check_copy('DELTA.RXX' ,im_dir,1) 
foo=check_copy('CLEANUP.CMD' ,im_dir,1) 
foo=check_copy('GNUNDIFF.CMD' ,im_dir,1) 
foo=check_copy('DOGET.CMD' ,im_dir,1) 
foo=check_copy('*.EXE',im_dir,1)
foo=check_copy('COPYING.GNU',im_dir,1)
foo=check_copy('*.TXT',im_dir,1)
foo=check_copy('*.DOC',im_dir,1)

say "Copying  .DLL files to " dll_dir
foo=check_copy('RXGDIFF.DLL',dll_Dir,1)
foo=check_copy('GNUREGEX.DLL',dll_Dir,1)

foo=check_copy('RXGDIFF.DLL',im_Dir,1)
foo=check_copy('GNUREGEX.DLL',im_Dir,1)


/* now, modify SRE2002.CFG */
say
isdef=yesno('Would you like DELTA to be the default "IM" module','No Yes','Yes')
cfgfile=cfg_dir||'\SRE2002.CFG'
aa=stream(cfgfile,'c','query exists')
if aa='' then do
    say "Unable to find: "cfgfile
    say "You'll need to modify your SRE2002 configuration file, and add "
    say ", DELTA "im_dir " to the IM_TYPES parameter "
end 
else do
  say "Modifying "cfgfile
  call modify_cfg 

end 

/* -- add to ADD_PLUG.DAT */
if is_upgrade<>1 then foo=add_plug(cfg_dir,isdef)

say
say cy_Ye"The DELTA IM module has been successfully installed "normal
say bold"Notes:"normal
say "   *  DELTA.RXX (in "im_dir")"
say "       contains a few user-configurable parameters."
say "   *  See DELTA.DOC for more info on delta encoding "


exit


/*****************/
/* Add a record  to the add_plug.dat file */
add_plug:procedure expose ipaddr expose reverse bold normal re_wh cy_ye aesc im_dir

parse arg cfgdir,isdef

/* read users.in, append uname pwd , write it*/
afile=strip(cfgdir,'t','\')||'\ADD_PLUG.DAT'

oof='0d0a0d0a'x
oof=oof||'Name: The Delta IM module '||'0d0a'x
oof=oof||'Desc: The Delta IM (instance manipulation) module enables Delta-encoding.'||'0d0a'x
if isdef=1 then oof=oof||'Desc: The Default IM will be set to DELTA. '||'0d0a'x
oof=oof||'Desc: This module will be added to currently selected IM_TYPES '||'0d0a'x
oof=oof||'Item: APPEND IM_TYPES  DELTA '||im_dir||'\DELTA.RXX'||'0d0a'x
if isdef=1 then oof=oof||'Item: IM_DEFAULT DELTA '||'0d0a0d0a'x

foo=append_file(afile,oof,2,1)
if foo<0 then 
  say 'Error ('foo') adding to 'afile
else
  say "sreLite2 installation record added to " afile

return 1


/********/
modify_cfg:


foo=strip(translate(stream(cfgfile,'c','open read')))
if abbrev(foo,'READY')=0 then do
   say reverse'ERROR:'normal' can not open  'cfgfile
   exit
end 
isz=stream(cfgfile,'c','query size')
if (isz=0 | isz='') then do
   say reverse'ERROR:'normal' empty or missing 'cfgfile
   rexit
end 
stuff=charin(cfgfile,1,isz)
foo=stream(cfgfile,'c','close')

newstuff=''
do forever
   if stuff='' then leave
   parse var stuff aline '0d0a'x stuff ; aline=strip(aline)
   if aline='' |  abbrev(aline,';')=1 then do
       newstuff=newstuff||aline||'0d0a'x
       iterate
   end

   parse var aline avar '=' aval
   avar=strip(translate(avar))
   select
      when avar='IM_TYPES' then do
          foo=pos('DELTA ',aval)
          if foo=0 then do
            if aval<>'' then
                newstuff=newstuff||avar||'='||aval', DELTA '||im_dir||'\DELTA.RXX'||'0d0a'x
            else
               newstuff=newstuff||avar||'='||'DELTA '||im_dir||'0d0a'x
          end
          else do               /* replace DELTA entry */
              aline2=translate(aline)
              aline='IM_TYPES = '
              parse var aline2 . '=' a1 'DELTA ' . ',' a2
              a1=strip(a1)
              a1=strip(a1,,',')
              if a1<>'' then a1=a1||', '
              aline=aline||a1
              aline=aline||' DELTA '||im_dir||'\DELTA.RXX '
              if a2<>'' then aline=aline', 'a2
              newstuff=newstuff||aline||'0d0a'x
          end
      end 
      when avar='IM_DEFAULT' & isdef=1 then do    
          newstuff=newstuff||avar||'='||' DELTA '||'0d0a'x
      end
      otherwise do
         newstuff=newstuff||aline||'0d0a'x
      end
   end  
end 

bakfile=cfg_dir||'\OLD\SRE2002.???'
bakfile=dostempname(bakfile)
say cfgfile||' is being renamed as 'bakfile
foo=dosrename(cfgfile,bakfile)
if foo=0 then  do
   say " ERROR: Unable to rename "cfgfile" to "bakfile
   exit
end
foo=stream(cfgfile,'c','open write')
arf=charout(cfgfile,newstuff,1)
if arf<>0 then do
     say "ERROR writing new version of "cfgfile
    exit
end
foo=stream(cfgfile,'c','close')
return 1


/************/
make_dirs:

nowdir=directory()
adrive=filespec("drive",nowdir)

/* can we use values from a recent sre2002 install */
a=value('SREINSTALL_SRE2002_DIR',,'os2environment')
if a<>'' & a<>'(null)' then do
    defname=a
end 
else do
    defname=adrive||'\SRE2002'
end


call lineout, bold  " What is SRE2002's "working" directory? " normal
say "    *  The DELTA files will be copied to a subdirectory "

n1:
godir=get_dir(defname)

return 0


/* ------------------------ */
/* ask for directory name,use defname2 as default */
/* give user opportunity to create it */

get_dir:procedure expose normal reverse bold re_wh im_dir csh_dir
/* procedure expose reverse normal bold */
parse arg defname2 , mustsub
defname0=defname2

n2:
call charout ,  reverse ' <ENTER>=' defname2  normal ' ?'
pull godir

if godir=" " then godir=defname2
if godir="n.a." then signal n2

godir=strip(godir,'t','\')
godir0=godir
if right(godir,1)=':' then godir=godir'\'

if  dosisdir(godir)=0 then do
   say "    Could not find  " godir
   signal n2
end

gdname=godir0||"\SRE2002.CMD"
foo=sysfiletree(gdname,'gname2','F')
if gname2.0=0 then do
   say
   say " ERROR: SRE2002.CMD is not currently installed in "godir
   signal n2
end

say ' '
/* create the directory for delta code */

im_dir=godir'\BIN\IM\DELTA'
if dosisdir(im_dir)=0 then do
  oo=sysmkdir2(im_dir)
  if oo=0  then do
           say "      Directory created: " im_dir
  end
  else do
      say "ERROR: Could not create " im_dir "(error = " oo
      exit
  end
end
im2=im_dir'\deltacache'
if dosisdir(im2)=0 then do
  oo=sysmkdir2(im2)
  if oo=0  then do
           say "      Directory created: " im2
  end
  else do
      say "ERROR: Could not create " im2 "(error = " oo
      exit
  end
end

say "Copying DELTA files to "im_dir


/* create a "cache" directory for delta */
csh_dir=godir0'\TEMP\DELTA'
adrive=left(csh_dir,1)
ff=dosfilesys(adrive)
if abbrev(ff,'HP')=0 then do
   do forever
      say "Warning: the SRE2002 drive ("adrive") is not HPFS " 
      say "         The drive used for delta caching must be HPFS. "
      say " Please enter a directory, on an HPFS drive, to use for the DELTA cache "
      call charout , ' ? '
      pull aa
      if aa=''  then iterate
      adrive=left(aa,1)
      ff=dosfilesys(adrive)
      if abbrev(ff,'HP')=0 then do
          say aa " is not on an HPFS drive "
          iterate
      end
      csh_dir=aa
      leave
   end   
end 
aa0=strip(csh_dir,,'\')
if right(aa0,1)=':' then aa0=aa0'\'

if dosisdir(aa0)=0 then do
  oo=sysmkdir2(aa0)
 if oo=0  then do
           say "      Directory created: " csh_dir
 end
 else do
      say "ERROR: Could not create " csh_dir "(error = " oo
      exit
 end
end
else do
   say "Using delta cache directory: "csh_dir
end

return godir



/* ------------------------------------------------------------------ */
 /* function: Check if ANSI is activated                               */
 /*                                                                    */
 /* call:     CheckAnsi                                                */
 /*                                                                    */
 /* where:    -                                                        */
 /*                                                                    */
 /* returns:  1 - ANSI support detected                                */
 /*           0 - no ANSI support available                            */
 /*          -1 - error detecting ansi                                 */
 /*                                                                    */
 /* note:     Tested with the German and the US version of OS/2 3.0    */
 /*                                                                    */
 /*                                                                    */
 CheckAnsi: PROCEDURE
   thisRC = -1
 
   trace off
                         /* install a local error handler              */
   SIGNAL ON ERROR Name InitAnsiEnd
 
   "@ANSI 2>NUL | rxqueue 2>NUL"
 
   thisRC = 0
 
   do while queued() <> 0
     queueLine = lineIN( "QUEUE:" )
     if pos( " on.", queueLine ) <> 0 | ,                       /* USA */
        pos( " (ON).", queueLine ) <> 0 then                    /* GER */
       thisRC = 1
   end /* do while queued() <> 0 */
 
 InitAnsiEnd:
 signal off error
 RETURN thisRC


/* ------------- */
/* ----------------------------------------------------------------------- */
/* REPLACESTRG: In string astring, find first occurence substring target and
.   replace it with substring putme
.      if no target, return unchanged astring
.      if no putme, then remove target
.      if type=backward, then find/change LAST occurence
.      if type=all, find/change all occurences
.      if exactmatch=yes, then do not capitalize during search (exact match only */
/* ----------------------------------------------------------------------- */

replacestrg: procedure

exactmatch=0
backward=0 ; doall=0

parse arg astring ,  target   , putme , type , exactmatch

type = translate(type)
if type="BACKWARD" then backward="YES"
if type="ALL" then doall="YES"

iat=1
joelen=length(target)
joelen2=length(putme)

doagain:                /* here if doall=yes */
 if exactmatch="YES" then do
    if   backward="YES" then
        joe= lastpos(target,astring)
    else
        joe= pos(target,astring,iat)
 end
 else do
   if   backward="YES" then
        joe= lastpos(translate(target),translate(astring))
    else
        joe= pos(translate(target),translate(astring),iat)
 end
 if joe=0 then
         return astring

 astring=delstr(astring,joe,joelen)
 if putme<>' ' then
    astring=insert(putme,astring,joe-1)

 if doall="YES" then do
     iat=joe+joelen2
     signal doagain
 end
/* else, all done */
 return astring

/*******************************************/
/* check for existence of file, then ask user to copy or not */
/* note that for X.* type copies, it only checks once
   (not for each file, but just for any one of them */
/********************************************/
check_copy: procedure expose copyall reverse bold normal
parse arg file1, dest1 , asis
amess=''

if asis="" then do
  dest2=strip(dest1,'t','\')||'\'
  filename=dest2||file1
end
else do
  filename=dest1
end /* do */

if copyall=1 then signal doit3

aa=sysfiletree(filename,'isit','F')

ok=1
if aa<>0 then do
   say " Warning: error when looking for pre-existing copy of: " filename
   ok=yesno(" Do you want to copy this file (or files) anyways? ",'No Yes','Y')
   if ok=1 & amess<>""  then
      ok=yesno(amess)
end

if isit.0>0 then do
  if pos('*',file1)=0 then do
      say " "
      say " A file exists with the name: " filename
      ok=yesno(" Do you want to overwrite this file? ",1)
       say ' '
      if ok=1 & amess<>""  then
           ok=yesno(amess)
  end
  else do
    say " "
      say " There is at least one file that matches: " filename
      say "  (this match may " bold " not " normal " be one of the files that will be copied!) "
      ok=yesno(" Do you want to copy these files? ",1)
      say ' '
      if ok=1 & amess<>""  then
           ok=yesno(amess)
  end  /* Do */

end

if ok=2 then do
  say " "
  say "A number of files will be overwritten (not just this one) "
  copyall=yesno(" Are you sure you want to do this?")
  if copyall=0 then
      ok=yesno(" Do you want to overwrite the current file (or files)? ")
      say ' '
end

if ok=0  then return 0

doit3:          /* jump here if copyall is on, or noask=1 */
'@COPY ' file1 dest1 ' > NUL '

return 1

/* return 1 if adir is an existing (possibly empty) directory , 0 if not */
ais_dir:procedure 
parse arg adir

adir=strip(adir)
adir=strip(adir,'t','\')
nowdir=directory()
nowdrive=filespec('d',nowdir'\')
nowpath=filespec('p',nowdir'\')
adr=filespec('d',adir)
if adr='' then do
   if abbrev(adir,'\')=0 then 
       adir=nowdrive||nowpath||adir
   else
       adir=nowdrive||adir
end /* do */

foo=sysfiletree(adir,goo,'D')
if  goo.0>0  then return 1
return 0


/* -------------------- */
/* get a yes or no , return 1 if yes */
yesno0:procedure expose normal reverse bold
parse arg fooa , allopt
ayn='  '||bold||'Y'||normal||'es\'||bold||'N'||normal||'o'
do forever
 foo1=normal||reverse||fooa||normal||ayn
 call charout,  foo1 normal ':'
 pull anans
 if abbrev(anans,'Y')=1 then return 1
 if abbrev(anans,'N')=1 then return 0

end

/* -------------------- */
/* choose between 3 alternatives (by default,a yes or no ),
return 1 if yes (or 0,1,2 for chosen altenative ) */

yesno:procedure expose normal reverse bold cy_ye got_rexxutil opsys noansi varname preimg postimg
parse arg amessage , altans,def,arrowok
ony2:
aynn=' '
if def='' then
 defans=''
else
 defans=translate(left(strip(def),1))
if altans='' then altans='No Yes'

w.0=words(altans)
goo=aynn
do iw0=1 to w.0
     w.iw0=strip(word(altans,iw0))
     a.iw0=translate(left(w.iw0,1))
     aa.iw0=substr(w.iw0,2)
     aynn=aynn||bold
     if  a.iw0=defans then aynn=aynn||cy_ye
     aynn=aynn||a.iw0||normal||aa.iw0
     goo=goo||a.iw0||aa.iw0
     if iw0<w.0 then do
       if noansi=0 then
          aynn=aynn'  '
       else
          aynn=aynn'  '
       goo=goo||'  '
     end
end
if arrowok=1 then aynn=aynn||' [UP]'

do forever
 foo1=normal||reverse||amessage||'? '||normal||aynn||': 'normal
 goo=amessage'?'||goo':'

 if length(goo)<73 then do
    call charout,foo1
 end
 else do
    foo1=normal||reverse||amessage||'? '||normal
    say foo1
    call charout,'     : 'aynn||': 'normal
 end

 if got_rexxutil =1 then do
    anans=translate(sysgetkey('echo'))
 end
 else do
    pull anans
    anans=left(strip(anans),1)
 end

 if anans='?' then do   /* asking for help */
     call online_help varname
     say
     signal ony2
 end 

 ianans=c2d(anans)
 if anans='' | ianans=13 | ianans=10 then  anans=defans

 if arrowok=1 & ianans=0 & got_rexxutil=1 then do
     ians=c2d(sysgetkey('noecho'))
     if ians=72 then  do
           say ;say
           return -1  /* -1 : up key */
     end
 end /* do */

 do ijj=1 to w.0
    if abbrev(anans,a.ijj)=1 then do
        say
        return Ijj-1
    end
 end /* do */
 call charout,'0d'x
end


/* ------------- */
sysmkdir2:procedure
parse arg adir

adir=strip(adir,'t','\')
ff=sysmkdir(adir)
if ff=0 then return ff

/* make the tree */
f2=adir'\'
dd=filespec('d',f2)
pp=filespec('p',f2)
if pp='\' | pp='' then return -1

pp2=strip(translate(pp,' ','\'))

do mm=1 to words(pp2)
   a1=subword(pp2,1,mm)
   a1=translate(a1,'\',' ')
   dd2=dd'\'a1
   hoo=sysmkdir(dd2)
   if hoo=0 then say ' ... creating: 'dd2  
end /* do */

return hoo


/********************/
append_file:procedure
parse arg filename,astring,ntries,addcrlf

if ntries='' | ntries=0 then ntries=1
isnew=0

fulln=stream(filename,'c','query exists')

if fulln<>'' then do    /* does exist, get size */
 do ll=1 to ntries               /* sometimes file exists but hasn't been written */
   asize=stream(fulln,'c','query size')
   if asize=''  then do
     if ll=ntries then  return '-1 '||filename' problem reading size '
     call syssleep(1)
     iterate
   end
   leave
 end
end
else do
   fulln=filename               /* create file */
   isnew=1
end

/* now open it */
do jj=1 to ntries
   astat=stream(fulln,'c','open')
   if abbrev(strip(translate(astat)),'READY')=0 then do
     if jj=ntries  then  return '-1 '||fulln' could not be opened'
     call syssleep(1)
     iterate
   end
   leave
end
  
/* if no such file, create it now */
if isnew=1 | asize=0  then do
   if addcrlf=1 then astring=astring||'0d0a'x
   foo=charout(fulln,astring,1)
   foo2=stream(fulln,'c','close')
   if foo<>0 then return '-2 unable to write 'foo' bytes '
   asize=length(astring)
   return asize
end

/* now get last 3 characters  */
iat=asize-2
toget=3
if iat<3 then do 
   toget=1   /* just look for 1a */
   iat=asize
end
aa=charin(fulln,iat,toget)

iwrite=asize+1          /* where to write astring */

checkcrlf=addcrlf
if toget=1 then do      /* just check 1a */
  if aa='1a'x then iwrite=asize
  checkcrlf=0
end 
else do         /* check last char for 1a */
  if right(aa,1)='1a'x then do
     iwrite=asize
     aa=left(aa,2)
  end 
  else do
    aa=right(aa,2)      /* no 1a, so check last two chars for crlf */
  end 
end 

if checkcrlf=1 then do
  if toget=3 then do      /* look for termainating crlf */
    if aa<>'0d0a'x then astring='0d0a'x||astring
  end
end
if addcrlf=1 then astring=astring||'0d0a'x

/* ready to write */

foo=charout(fulln,astring,iwrite)
foo2=stream(fulln,'c','close')
if foo<>0 then return '-2 problem writing 'foo' bytes '
asize=length(astring)+iwrite-1
return asize




